mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('polls/', include('polls.urls')),  # polls = sondaggi
    path('', include('events.urls')),       # events = eventi per calendario
]

mysite/polls/urls.py
"""mysite URL Configuration"""

from django.urls import path
from . import views

app_name = 'polls'
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'), # ex: /polls/
    path('<int:pk>/', views.DetailView.as_view(), name='detail'),
    # '<int:question_id>/', views.detail, -> ex: /polls/1/
    path('<int:pk>/results/', views.ResultsView.as_view(), name='results'),
    # '<int:question_id>/results/', views.results, -> ex: /polls/1/results/
    path('<int:question_id>/vote/', views.vote, name='vote'), # ex: /polls/1/vote/
]

# remove our old index, detail, and results views and use Django’s generic views : from <question_id> to <pk>.

mysite/polls/models.py
# Create your models here.
"""
remember the three-step guide to making model changes:
- Change your models (in models.py).
- Run python manage.py makemigrations to create migrations for those changes
- Run python manage.py migrate to apply those changes to the database.
"""
from django.db import models
import datetime
from django.utils import timezone
from django.contrib import admin

# Create a database schema (CREATE TABLE statements) for this app.
class Question(models.Model):
    question_text = models.CharField(max_length=200)
    pub_date = models.DateTimeField('date published')

    def __str__(self):
        return self.question_text

    @admin.display(
        boolean=True,
        ordering='pub_date',
        description='Published recently?',
    )

    def was_published_recently(self):
        now = timezone.now()
        return now - datetime.timedelta(days=2) <= self.pub_date <= now #  it will only return True if the date is also in the past
        # return self.pub_date >= timezone.now() - datetime.timedelta(days=1) # it returns true if pub_date is in the future

# Create a Python database-access API for accessing Question and Choice objects.
class Choice(models.Model):
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    choice_text = models.CharField(max_length=200)
    votes = models.IntegerField(default=0)

    def __str__(self):
        return self.choice_text

mysite/polls/views.py
# https://docs.djangoproject.com -> source

# from django.shortcuts import render
# Create your views here.
""" Each view is responsible for doing one of two things: returning an HttpResponse object
containing the content for the requested page, or raising an exception such as Http404. """

from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.urls import reverse
from django.views import generic
from django.utils import timezone

from .models import Choice, Question


class IndexView(generic.ListView):  # display a list of objects
    template_name = 'polls/index.html'
    context_object_name = 'latest_question_list'

    def get_queryset(self):
        """Return the last five published questions. Not including those in the future"""
        return Question.objects.filter(
            pub_date__lte=timezone.now() # pub_date <= timezone.now
        ).order_by('-pub_date')[:5]

class DetailView(generic.DetailView): # display a detail page for a particular type of object
    model = Question
    template_name = 'polls/detail.html'

class ResultsView(generic.DetailView):
    model = Question
    template_name = 'polls/results.html'

def vote(request, question_id):
    # return HttpResponse("You're voting on question %s." % question_id)
    question = get_object_or_404(Question, pk=question_id)
    try:
        selected_choice = question.choice_set.get(pk=request.POST['choice'])  # request.POST is a dictionary-like object that lets you access submitted data by key name.
        # In this case, request.POST['choice'] returns the ID of the selected choice, as a string.
    except (KeyError, Choice.DoesNotExist):
        # Redisplay the question voting form.
        return render(request, 'polls/detail.html', {
            'question': question,
            'error_message': "You didn't select a choice.",
        })
    else:
        selected_choice.votes += 1
        selected_choice.save()
        # Always return an HttpResponseRedirect after successfully dealing with POST data.
        # This prevents data from being posted twice if a user hits the Back button.
        return HttpResponseRedirect(reverse('polls:results', args=(question.id,)))
        # reverse function helps avoid having to hardcode a URL in the view function: will return a string like '/polls/1/results/'

"""
def home(request):

    return render(request,'home.html', {})


def index(request):
    # return HttpResponse("Hello, world. You're at the polls index.")
    latest_question_list = Question.objects.order_by('-pub_date')[:5]
    # output = ', '.join([q.question_text for q in latest_question_list])
    # return HttpResponse(output)
    # template = loader.get_template('polls/index.html')
    context = {'latest_question_list': latest_question_list}
    # return HttpResponse(template.render(context, request))
    return render(request, 'polls/index.html', context)

def detail(request, question_id):
    # return HttpResponse("You're looking at question %s." % question_id)
    question = get_object_or_404(Question, pk=question_id)
    return render(request, 'polls/detail.html', {'question': question})

def results(request, question_id):
    # response = "You're looking at the results of question %s."
    # return HttpResponse(response % question_id)
    question = get_object_or_404(Question, pk=question_id)
    return render(request, 'polls/results.html', {'question': question})
"""

mysite/polls/templates/polls/detail.html
{% extends 'events/base.html' %}
{% block content %}
    <form action="{% url 'polls:vote' question.id %}" method="post">
        {% csrf_token %}
        <fieldset>
            <legend><h1>{{ question.question_text }}</h1></legend>
            {% if error_message %}<p><strong>{{ error_message }}</strong></p>{% endif %}
            {% for choice in question.choice_set.all %}
                <input type="radio" name="choice" id="choice{{ forloop.counter }}" value="{{ choice.id }}">
                <label for="choice{{ forloop.counter }}">{{ choice.choice_text }}</label><br>
            {% endfor %}
        </fieldset>
        <input type="submit" value="Vote">
    </form>
{% endblock %}

mysite/polls/templates/polls/index.html
{% extends 'events/base.html' %}
{% block content %}
<h1>Questions: </h1>
    {% if latest_question_list %}
      <ul>
      {% for question in latest_question_list %}
        <li><a href="{% url 'polls:detail' question.id %}">{{ question.question_text }}</a></li>
      {% endfor %}
      </ul>
    {% else %}
        <p>No polls are available.</p>
    {% endif %}
{% endblock %}

<!--
     <link rel="stylesheet" href="/Users/caterinatobia/PycharmProjects/sitoDjangoBlueTensor/mysite/polls/static/polls/style.css">
    {% load static %}
    <link rel="stylesheet" href="{% static 'polls/style.css' %}">
-->

mysite/polls/templates/polls/results.html
{% extends 'events/base.html' %}
{% block content %}
  <h1>{{ question.question_text }}</h1>
        <ul>
        {% for choice in question.choice_set.all %}
            <li>{{ choice.choice_text }} -- {{ choice.votes }} vote{{ choice.votes|pluralize }}</li>
        {% endfor %}
        </ul>
    <a href="{% url 'polls:detail' question.id %}">Vote again?</a>
{% endblock %}